function [Phij1,Phij2,ORDPS] = pswf1d_sep_mexpp(X,Z,c,V,lambda,thrwin)
%% function [Phij1,Phij2,ORDPS] = pswf1d_sep(X,Z,c,V,lambda,thrwin);
% generate separated representation of complex exponential
%
% X: xi part
% Z: S2(nu,y) part
% c: bandwidth
% V: expansion coefficients
% lambda: eigenvalues
% thrwin: window for xi part; 0 for where max|S2(nu,y)| * xi >c, 1 otherwise
% Phiij1, Phiij2: xi and S2(nu,y) part of tensor product representation
%   Phiij1 is set to magnitude 1 when max|S2(nu,y)| * xi >c
% ORDPS: tensor product rank


ORDLP=length(V);
ORDPS=length(lambda);

ORDPS=ORDPS-1;

% normalize arguments
MZ=max(abs(Z(:)));
MX=max(abs(X(:)));
nZ=Z/MZ;
nX=X/c*MZ;
max(nX(:));
max(nZ(:));
nXwin=nX.*thrwin;

LPVNX=   legendrepolpp((nXwin(:)),ORDLP+1);
LPVNZ=   legendrepolpp((nZ(:)),ORDLP+1);
LPVNT=   legendrepolpp(-1+1e-4,ORDLP+1);
[PST]=legendre2pswfpp(LPVNT,V,ORDPS);
signcorr=sign(PST);
[Phij1,Phij2]=legendre2pswfxzpp(LPVNX,LPVNZ,V,ORDPS,signcorr,lambda);



