function [XX,YY,xg,yg] = reg_inpolypp(xypol,xy0,dd)
%% function [XX,YY,xg,yg] = reg_inpolypp(xypol,xy0,dd)
% create points within border xypol lying on grid defined by base point xy0 and resolution dd

[a,b]=size(xypol); if b>a; xypol=xypol'; end
x1=xypol(:,1); y1=xypol(:,2);

x1=x1(:);
y1=y1(:);

% define grid
x0=xy0(1);
y0=xy0(2);
dx=dd(1);
dy=dd(2);

x1=x1(:)-x0;
y1=y1(:);


mx=min(x1);Mx=max(x1);
my=min(y1);My=max(y1);
xg=ceil(mx/dx)*dx+x0:dx:floor(Mx/dx)*dx+x0;
yg=ceil(my/dy)*dy+y0:dy:floor(My/dy)*dy+y0;

% calculate line segments (normals/intersects)
px=[x1(1:end-1) x1(2:end)]; dpx=diff(px,1,2);   ny=dpx;
py=[y1(1:end-1) y1(2:end)]; dpy=diff(py,1,2);   nx=-dpy;
is=-nx.*px(:,1)-ny.*py(:,1);
ym=min(py,[],2); yM=max(py,[],2);
ymg=ceil(ym/dy)*dy+y0; yMg=floor(yM/dy)*dy+y0;

% eliminate horizontal elements
vid=find(yM-ym>0);
ym=ym(vid);
yM=yM(vid);
nx=nx(vid);
dpy=dpy(vid);
ny=ny(vid);
is=is(vid);

% tag if points are starting or stopping points on regular grid
stoptag=dpy<0;
starttag=dpy>0;


XX=[]; YY=[];
warning off
% step through second coordinate
LYG=length(yg);
for k=1:LYG;
    lineid=find((ym<=yg(k))&(yM>=yg(k)));
    xgk=(ceil(-(is(lineid)+ny(lineid)*yg(k))./nx(lineid)/dx)-stoptag(lineid))*dx;
    [xgk,sid]=sort(xgk);
    
    lineid=lineid(sid);
    if numel(lineid)
        id1=find(starttag(lineid));
        id2=find(stoptag(lineid));
        while numel(id1)>numel(id2); id1=id1(1:end-1); end
        while numel(id2)>numel(id1); id2=id2(2:end); end
        for m=1:length(id1);
            xtmp=xgk(id1(m)):dx:xgk(id2(m));
            ytmp=ones(size(xtmp))*yg(k);
            XX=[XX xtmp];
            YY=[YY ytmp];
        end
    end
end
XX=XX+x0;
warning on;
